# vrt_lss_clustering
Veeroute.LSS Clustering API

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 3.8.168672
- Package version: 3.8.168672
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python >= 3.6

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import vrt_lss_clustering
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import vrt_lss_clustering
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
import vrt_lss_clustering
from pprint import pprint
from vrt_lss_clustering.api import cluster_api
from vrt_lss_clustering.model.calculation_detail import CalculationDetail
from vrt_lss_clustering.model.cluster_result import ClusterResult
from vrt_lss_clustering.model.cluster_task import ClusterTask
from vrt_lss_clustering.model.inline_response400 import InlineResponse400
from vrt_lss_clustering.model.inline_response401 import InlineResponse401
from vrt_lss_clustering.model.inline_response403 import InlineResponse403
from vrt_lss_clustering.model.inline_response404 import InlineResponse404
from vrt_lss_clustering.model.inline_response415 import InlineResponse415
from vrt_lss_clustering.model.inline_response429 import InlineResponse429
from vrt_lss_clustering.model.inline_response500 import InlineResponse500
from vrt_lss_clustering.model.inline_response501 import InlineResponse501
from vrt_lss_clustering.model.inline_response502 import InlineResponse502
from vrt_lss_clustering.model.inline_response503 import InlineResponse503
from vrt_lss_clustering.model.inline_response504 import InlineResponse504
from vrt_lss_clustering.model.inline_response_default import InlineResponseDefault
from vrt_lss_clustering.model.plan_id import PlanId
# Defining the host is optional and defaults to https://api.veeroute.tech/v3
# See configuration.py for a list of all supported configuration parameters.
configuration = vrt_lss_clustering.Configuration(
    host = "https://api.veeroute.tech/v3"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure Bearer authorization (JWT): ApiKeyAuth
configuration = vrt_lss_clustering.Configuration(
    access_token = 'YOUR_BEARER_TOKEN'
)


# Enter a context with an instance of the API client
with vrt_lss_clustering.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = cluster_api.ClusterApi(api_client)
    cluster_task = ClusterTask(
        points=[
            ClusterPoint(
                key="location01",
                location=Location(
                    latitude=55.692789,
                    longitude=37.554554,
                    arrival_duration=15,
                    departure_duration=5,
                ),
                duration=30,
            ),
        ],
        performers=[
            Performer(
                key="performer0001",
                home_location=Location(
                    latitude=55.692789,
                    longitude=37.554554,
                    arrival_duration=15,
                    departure_duration=5,
                ),
                transport_type=TransportType("CAR"),
                cost_per_meter=0.05,
                cost_per_minute=0.12,
                limits=ClusterLimits(
                    min_points=3,
                    max_points=3,
                ),
            ),
        ],
        clusters=[
            Cluster(
                performer_key="performer01",
                points_keys=[
                    "point01",
                ],
                representer_key="point01",
            ),
        ],
        settings=ClusterSettings(
            configuration="optimize_money",
            calculation_time=30,
            result_ttl=10,
            transport_factor=[
                TransportFactor(
                    transport_type=TransportType("CAR"),
                    speed=2.5,
                ),
            ],
            routing=[
                Routing(
                    transport_type=TransportType("CAR"),
                    matrix=RoutingMatrix(
                        waypoints=[
                            Waypoint(
                                name="central",
                                latitude=55.692789,
                                longitude=37.554554,
                                duration=15,
                            ),
                        ],
                        distances=[
                            MatrixLine([
                                -1,
                            ]),
                        ],
                        durations=[
                            MatrixLine(MatrixLine),
                        ],
                    ),
                    traffic_jams=[
                        TrafficFactor(
                            time_window=TimeWindow(
                                _from=dateutil_parser('2021-02-21T09:30:00+03:00'),
                                to=dateutil_parser('2021-02-21T19:45:00Z'),
                            ),
                            length_multiplier=2,
                            length_additive=20,
                            time_multiplier=2,
                            time_additive=30,
                        ),
                    ],
                ),
            ],
            assumptions=ClusterAssumptions(
                traffic_jams=False,
                flight_distance=True,
            ),
            precision=2,
            limits=ClusterLimits(
                min_points=3,
                max_points=3,
            ),
        ),
    ) # ClusterTask | New clustering request.

    try:
        # Clustering, synchronous call.
        api_response = api_instance.cluster(cluster_task)
        pprint(api_response)
    except vrt_lss_clustering.ApiException as e:
        print("Exception when calling ClusterApi->cluster: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.veeroute.tech/v3*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ClusterApi* | [**cluster**](docs/ClusterApi.md#cluster) | **POST** /clustering/cluster | Clustering, synchronous call.
*ClusterApi* | [**delete_result**](docs/ClusterApi.md#delete_result) | **DELETE** /clustering/result/{id} | Clustering result removal.
*ClusterApi* | [**get_result**](docs/ClusterApi.md#get_result) | **GET** /clustering/result/{id} | Clustering result.
*ClusterApi* | [**run_cluster**](docs/ClusterApi.md#run_cluster) | **POST** /clustering/run_cluster | Clustering process start.
*SystemApi* | [**check**](docs/SystemApi.md#check) | **GET** /clustering/check | Checking the service availability.
*SystemApi* | [**version**](docs/SystemApi.md#version) | **GET** /clustering/version | Getting the service version.
*ValidateApi* | [**validate**](docs/ValidateApi.md#validate) | **POST** /clustering/validate | Data validation for clustering.


## Documentation For Models

 - [CalculationDetail](docs/CalculationDetail.md)
 - [CheckResult](docs/CheckResult.md)
 - [Cluster](docs/Cluster.md)
 - [ClusterAssumptions](docs/ClusterAssumptions.md)
 - [ClusterLimits](docs/ClusterLimits.md)
 - [ClusterPoint](docs/ClusterPoint.md)
 - [ClusterResult](docs/ClusterResult.md)
 - [ClusterSettings](docs/ClusterSettings.md)
 - [ClusterTask](docs/ClusterTask.md)
 - [InlineResponse400](docs/InlineResponse400.md)
 - [InlineResponse401](docs/InlineResponse401.md)
 - [InlineResponse403](docs/InlineResponse403.md)
 - [InlineResponse404](docs/InlineResponse404.md)
 - [InlineResponse415](docs/InlineResponse415.md)
 - [InlineResponse429](docs/InlineResponse429.md)
 - [InlineResponse500](docs/InlineResponse500.md)
 - [InlineResponse501](docs/InlineResponse501.md)
 - [InlineResponse502](docs/InlineResponse502.md)
 - [InlineResponse503](docs/InlineResponse503.md)
 - [InlineResponse504](docs/InlineResponse504.md)
 - [InlineResponseDefault](docs/InlineResponseDefault.md)
 - [Location](docs/Location.md)
 - [MatrixLine](docs/MatrixLine.md)
 - [Performer](docs/Performer.md)
 - [PlanId](docs/PlanId.md)
 - [PlanInfo](docs/PlanInfo.md)
 - [PlanStatus](docs/PlanStatus.md)
 - [Routing](docs/Routing.md)
 - [RoutingMatrix](docs/RoutingMatrix.md)
 - [TimeWindow](docs/TimeWindow.md)
 - [TraceData](docs/TraceData.md)
 - [TrafficFactor](docs/TrafficFactor.md)
 - [TransportFactor](docs/TransportFactor.md)
 - [TransportType](docs/TransportType.md)
 - [UnclusteredPoint](docs/UnclusteredPoint.md)
 - [ValidateResult](docs/ValidateResult.md)
 - [Validation](docs/Validation.md)
 - [VersionResult](docs/VersionResult.md)
 - [Waypoint](docs/Waypoint.md)


## Documentation For Authorization


## ApiKeyAuth

- **Type**: Bearer authentication (JWT)


## Author

support@veeroute.com


## Notes for Large OpenAPI documents
If the OpenAPI document is large, imports in vrt_lss_clustering.apis and vrt_lss_clustering.models may fail with a
RecursionError indicating the maximum recursion limit has been exceeded. In that case, there are a couple of solutions:

Solution 1:
Use specific imports for apis and models like:
- `from vrt_lss_clustering.api.default_api import DefaultApi`
- `from vrt_lss_clustering.model.pet import Pet`

Solution 2:
Before importing the package, adjust the maximum recursion limit as shown below:
```
import sys
sys.setrecursionlimit(1500)
import vrt_lss_clustering
from vrt_lss_clustering.apis import *
from vrt_lss_clustering.models import *
```

